function WbxApp() {
  var self = this;
  this.cache = {}; // mustache template cache

  this.init = function () {
    var dlg = document.querySelector(".dialog");
    dlg.style.flexBasis = '0em';
    document.querySelector('.west').style.flexBasis = '0em';
    document.querySelector('.ost').style.flexBasis = '0em';
    self.zurueck_btn_aus();
    self.menue_binden();
    self.meldung_mit_timeout("Bereit.", 1500);
  };
  
  this.menue_binden = function() {
    self.addEvtListener('#mi-cms', 'click', self.cms_zeigen);
    self.addEvtListener('#mi-um', 'click', self.um_zeigen);
    self.addEvtListener('#mi-dok', 'click', self.dok_zeigen);
  };
  
  this.cms_zeigen = function() {
    window.location.href = '/file-cms/ui2';
  };
  
  this.um_zeigen = function() {
    window.location.href = '/um/ui';
  };
  
  this.dok_zeigen = function() {
    window.location.href = '/data/dok/wbx/bedienung.html#wbx-bedienung';
  };
  
  /* ---- Sonstiges --- */

  this.meldung_mit_timeout = function (meldung, timeout) {
    var s = document.querySelector('.sued');
    s.textContent = meldung;
    if (!s.classList.contains('sued-open')) {
      s.classList.add('sued-open');
      s.style.height = '1.5em';
    }
    setTimeout(function () {
      s.textContent = 'Bereit.';
      setTimeout(function () {
        var suedDiv = document.querySelector('.sued');
        if (suedDiv.classList.contains('sued-open')) {
          suedDiv.classList.remove('sued-open');
          suedDiv.style.height = '0';
        }
      }, 500);
    }, timeout);
  };  

  /* ---- Steuerung Bedienelemente ---- */
  
  this.zurueck_btn_ein = function(callback) {
    var btn = document.querySelector('.zurueck-btn');
    btn.addEventListener('click', callback);
    btn.style.color = 'black';
  };
  
  this.zurueck_btn_aus = function(listener) {
    var btn = document.querySelector('.zurueck-btn');
    btn.removeEventListener('click', listener);
    btn.style.color = '#eee';    
  };
    
  /* ----- Hilfsfunktionen ----- */

  this.serialisieren = function(obj) {
    return '{"' + obj.constructor.name + '":' + JSON.stringify(obj) + '}';
  };
  
  this.addEvtListener = function(selector, eventName, func) {
    var elems = document.querySelectorAll(selector);
    var index;
    for (index = 0; index < elems.length; index++) {
      elems[index].addEventListener(eventName, func);
    }
  };
  
  this.removeAllListeners = function(id) {
    var el = document.getElementById(id);
    elClone = el.cloneNode(true);
    el.parentNode.replaceChild(elClone, el);
  }; // https://stackoverflow.com/questions/19469881/remove-all-event-listeners-of-specific-type

  /* ---- Vorlagen ---- */

  this.html_erzeugen = function(vurl, inhalt, cb) {
    var vorlage = self.cache[vurl];
    if(vorlage === undefined) {
      self.vorlage_laden_und_fuellen(vurl, inhalt, cb);
    } else {
      self.vorlage_fuellen(vurl, inhalt, cb);
    }
  };

  this.vorlage_fuellen = function(vurl, inhalt, cb) {
    cb(Mustache.render(self.cache[vurl], inhalt));
  };

  this.vorlage_laden_und_fuellen = function(vurl, inhalt, cb) {
    app.http_get(vurl, function(antwort) {
      self.cache[vurl] = antwort;
      self.vorlage_fuellen(vurl, inhalt, cb);
    });
  };

  
}
